LeetCode Unique Paths

A robot is located at the top-left corner of a m x n grid (marked 'Start' in the diagram below).

The robot can only move either down or right at any point in time. The robot is trying to reach the bottom-right corner of the grid (marked 'Finish' in the diagram below).

How many possible unique paths are there?


Above is a 3 x 7 grid. How many possible unique paths are there?

Note: m and n will be at most 100.

思路分析:这题开始想到用DFS 搜索来做,一般搜索从S到F的路径一边count路径的数量,但是算法时间复杂度太高,用DFS算法时间复杂度为O(2^(m+n)),是指数级复杂度。其实,这题可以用DP得到更快的算法,具体而言,定义m*n维二维数组dp[][],dp[i][j]表示从s出发到达格子(i,j)的路径数目,现在我们可以思考如果写dp方程。通过观察网格特征和走法,我们可以分析得知,到达(i,j)只有两种走法,第一是从(i-1,j)向下到(i,j),第二是从(i,j-1)向右到(i,j),而dp[i][j-1]和dp[i-1][j]是已经保存的中间计算结果,所以可以得到dp递推方程为dp[i][j] = dp[i][j-1] + dp[i-1][j]。所以可以从(0,0)开始不断计算到右侧和下方的格子的路径总数,直到算出dp[m-1][n-1],算法时间复杂度为O(mn),空间复杂度也为O(mn)。其实还可以进一步节省空间,因为计算dp[i][j]时只需要知道相邻左侧一列或者上面一行的计算结果,因此我们只需要定义一个数组row或者col(取决于m和n哪个更小),然后也可以不断推算出dp[m-1][n-1].

AC Code

public class Solution {
    public int uniquePaths(int m, int n) {
        //dp[i][j] = dp[i-1][j] + dp[i][j-1];
        int [][] dp = new int[m][n];
        for(int i = 0; i < m; i++){
            dp[i][0] = 1;
        }
        for(int j = 0; j < n; j++){
            dp[0][j] = 1;
        }
        for(int i = 1; i < m; i++){
            for(int j = 1; j< n; j++){
                dp[i][j] = dp[i-1][j] + dp[i][j-1];
            }
        }
        
        return dp[m-1][n-1];
    }
}


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 1
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论 1
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值